function [d2,z]=distechel(u,v)
% function [d2,z]=distechel(u,v)
% P.Comon, 2 July, 1998; 
% P.Comon modified 15 jan 2004 (function phase replaced by angle)
% Distance carree entre u/norm(u) et v/norm(v)*exp(i*phi)
% ou phi annule la phase de u'*v.
% On montre que cette distance minimize par rapport a z la distance
% relative norm(u-z*v)^2/norm(u)/norm(z*v).
% Cette distance est donc invariante a un facteur multiplicatif 
% scalaire complexe.

phi=-angle(u'*v);ii=sqrt(-1);
u=u(:)/norm(u);v=v(:)/norm(v);
temp=u-v*exp(ii*phi);
d2=temp'*temp;
z=norm(v)/norm(u)*exp(ii*phi);

%% calcul direct (ne donnant pas z):
%c=abs(u'*v)/norm(u)/norm(v);d2=2*(1-c);
