function PP=pzz2pX(t1111,t1112,t1122,t1221,t1222,t2222)
% PP=pzz2pX(t1111,t1112,t1122,t1221,t1222,t2222)
% P.Comon, June 12, 1998
% Polynome en 4 variables reellles associe a 1 tenseur complexe 
% circulaire de dimension 2
% t1221 est reel par construction, ainsi que t1111 et t2222
% Voir la fonction zz2X.m

Ret1112=real(t1112);Imt1112=imag(t1112);
Ret1122=real(t1122);Imt1122=imag(t1122);
Ret1222=real(t1222);Imt1222=imag(t1222);

PP=[
t1111;               % x1^4         
4*Ret1112;           % x1^3 x2        
0;                   % x1^3      y1
4*Imt1112;           % x1^3           y2
4*t1221+2*Ret1122;   % x1^2 x2^2       
-4*Imt1112;          % x1^2 x2   y1 
4*Imt1122;           % x1^2 x2        y2 
2*t1111;             % x1^2      y1^2    
4*Ret1112;           % x1^2      y1   y2
4*t1221-2*Ret1122;   % x1^2           y2^2  
4*Ret1222;           % x1   x2^3     
-4*Imt1122;          % x1   x2^2 y1   
4*Imt1222;           % x1   x2^2      y2        
4*Ret1112;           % x1   x2   y1^2        
8*Ret1122;           % x1   x2   y1   y2        
4*Ret1222;           % x1   x2        y2^2  
0;                   % x1        y1^3     
4*Imt1112;           % x1        y1^2 y2      
4*Imt1122;           % x1        y1   y2^2      
4*Imt1222;           % x1             y2^3    
t2222;               %      x2^4         
-4*Imt1222;          %      x2^3 y1 
0;                   %      x2^3      y2
4*t1221-2*Ret1122;   %      x2^2 y1^2     
4*Ret1222;           %      x2^2 y1   y2    
2*t2222;             %      x2^2      y2^2 
-4*Imt1112;          %      x2   y1^3    
-4*Imt1122;          %      x2   y1^2 y2
-4*Imt1222;          %      x2   y1   y2^2 
0;                   %      x2        y2^3  
t1111;               %           y1^4         
4*Ret1112;           %           y1^3 y2       
4*t1221+2*Ret1122;   %           y1^2 y2^2      
4*Ret1222;           %           y1   y2^3        
t2222;               %                y2^4         
];
